BOFS/default/views.py
from builtins import str
from builtins import range
import datetime
from flask import Blueprint, render_template, current_app, request, make_response, _app_ctx_stack
from BOFS.util import *
from BOFS.globals import db, referrer, page_list, questionnaires
from BOFS.BOFSFlask import BOFSSessionInterface, BOFSSession
import os.path
import uuid


default = Blueprint('default', __name__)


@default.route("/")
@verify_correct_page
def route_index():
    return "You shouldn't be able to see this."


@default.route("/consent", methods=['POST', 'GET'])
@verify_correct_page
def route_consent():
    """
    This shows a consent form. Upon submission, the participant entry is created in the database, they
    are assigned a condition, and the session variables are set.
    This is typically the first page you will use in PAGE_LIST. If not, use one of
    * `/consent_nc`
    * `/create_participant`
    * `/create_participant_nc`
    :return:
    """
    if request.method == 'POST':
        if 'email' in request.form and request.form['email'] != '':
            # We caught someone with our honeypot.
            return render_template("consent.html")

        provide_consent(True)
        return redirect("/redirect_next_page")

    return render_template("consent.html")


# Sets a participant's condition to 0 instead of assigning it as normal
@default.route("/consent_nc", methods=['POST', 'GET'])
@verify_correct_page
def route_consent_nc():
    """
    This acts just like `/consent`, except it does not assign the user a condition (defaults to 0).
    :return:
    """
    if request.method == 'POST':
        provide_consent(False)
        return redirect("/redirect_next_page")
    return render_template("consent.html")


# Use this route in place of /consent, if you want to bypass the consent form.
@default.route("/create_participant")
def route_create_participant():
    """
    This creates the participant in the database and sets up the session variables. Use if you don't need to
    show a consent form.
    :return:
    """
    provide_consent(True)
    return redirect("/redirect_next_page")


# Use this route in place of /consent_nc, if you want to bypass the consent form without assigning a condition.
@default.route("/create_participant_nc")
def route_create_participant_nc():
    """
    This creates the participant in the database and sets up the session variables. Use if you don't need to
    show a consent form.
    This does not assign the participant a condition (defaults to 0)
    and so could be used in conjuction with `/assign_condition`.
    :return:
    """
    provide_consent(False)
    return redirect("/redirect_next_page")


@default.route("/assign_condition")
@verify_session_valid
@verify_correct_page
def route_assign_condition():
    """
    Typically conditions are assigned upon consent. Use this page if you want to assign a condition later on in
    the experiment. This might be used, for example, after several initial questionnaires, so that participants
    who fail to actually attempt the task don't end up getting assigned a condition.
    :return:
    """
    p = db.session.query(db.Participant).get(session['participantID'])
    p.assign_condition()
    db.session.commit()

    session['condition'] = p.condition

    return redirect("/redirect_next_page")


@default.route("/startMTurk", methods=['POST', 'GET'])  # Deprecated
@default.route("/start_mturk", methods=['POST', 'GET'])
@verify_correct_page
def route_start_mturk():
    """
    If we are using a platform where the user has a unique (and anonymous) ID associated with their account,
    then you can use this page to request that ID. This is set up to work with Mechanical Turk, but the
    template can be overwritten to request different types of ID.
    :return:
    """
    if request.method == 'POST':
        p = db.Participant.query.get(session['participantID'])
        p.mTurkID = str(request.form['mTurkID']).strip()
        p.code = uuid.uuid4().hex

        session['code'] = p.code
        session['mTurkID'] = p.mTurkID

        # Don't try to load any past attempts if this config option is set
        if not current_app.config['RETRIEVE_SESSIONS']:
            return redirect('/redirect_next_page')

        sessionFromMTurkID = db.session.query(db.SessionStore).\
            filter(db.SessionStore.mTurkID == p.mTurkID).\
            order_by(db.desc(db.SessionStore.createdOn)).all()

        allowRetakes = current_app.config['ALLOW_RETAKES']

        # This person has tried the task before and didn't finish. Let's load their information.
        # This will leave an orphaned participant in the DB (they will load up and use their old participantID).
        # If they had previously finished an attempt, then let them start over.
        if sessionFromMTurkID and len(sessionFromMTurkID) > 0:
            pFromMTurkID = db.session.query(db.Participant). \
                filter(
                    db.Participant.mTurkID == p.mTurkID,
                    db.Participant.participantID == sessionFromMTurkID[0].participantID
                )

            if allowRetakes:
                # If allow retakes is True, then don't try to re-load data from past attempts that were completed.
                pFromMTurkID = pFromMTurkID.filter(db.Participant.finished != True)

            pFromMTurkID = pFromMTurkID.all()

            # Load their old session
            if pFromMTurkID and len(pFromMTurkID) > 0:
                dictData = BOFSSessionInterface.serializer.loads(sessionFromMTurkID[0].data)
                for key in dictData.keys():
                    session[key] = dictData[key]

                # Ensure that if conditions are used, their incomplete attempt doesn't skew the counts.
                p.condition = None
                db.session.commit()

                # Their condition will be loaded from the session data already. This is extra insurance.
                for pPastAttempt in pFromMTurkID:
                    # Find the attempt that has the actual condition set (second attempts onward will have condition 0)
                    if pPastAttempt.condition != 0 and pPastAttempt.condition is not None:
                        session['condition'] = pPastAttempt.condition

                # Redirect them to where they should actually be, only if that location is not going to put them in a weird loop.
                # TODO: Dynamically create a list of pages to avoid redirecting to from PAGE_LIST
                if 'currentUrl' in dictData and session['currentUrl'] not in ('startMTurk', 'start_mturk', 'consent'):
                    return redirect(session['currentUrl'])

        return redirect('/redirect_next_page')

    return render_template('mturk_id.html')


@default.route("/questionnaire/<questionnaireName>", methods=['POST', 'GET'])
@default.route("/questionnaire/<questionnaireName>/<tag>", methods=['POST', 'GET'])
@verify_correct_page
def route_questionnaire(questionnaireName, tag=""):
    """
    Render a questionnaire.
    :param questionnaireName: The name of the json file (without the .json extension).
    :param tag: If the same questionnaire is to be displayed more than once, provide it with a
                unique tag (e.g., "before" or "after" or "1")
    :return:
    """
    q = questionnaires[questionnaireName]

    if request.method == 'POST':
        q.handle_questionnaire(tag)

        return redirect("/redirect_next_page")

    return render_template('questionnaire.html',
                           tag=tag,
                           q=q.jsonData,
                           timeStarted=datetime.datetime.utcnow())


@default.route("/redirect_previous_page")
def route_redirect_previous_page():
    """
    Sends a user to the previous page. This is intended primarily for debugging purposes.
    :return:
    """
    session['currentUrl'] = page_list.previous_path(session['currentUrl'])
    nextUrl = current_app.config["APPLICATION_ROOT"] + "/" + session['currentUrl']

    return redirect(nextUrl)


@default.route("/redirect_next_page")
def route_redirect_next_page():
    """
    This is the preferred way of sending a user to the next page.
    :return:
    """
    if not request is None and not request.referrer is None:
        currentPage = str.replace(str(request.referrer), request.host_url, "")
    else:
        currentPage = session['currentUrl']

    if currentPage == "end":
        return redirect(current_app.config["APPLICATION_ROOT"] + "/end")

    session['currentUrl'] = page_list.next_path(currentPage)
    nextUrl = current_app.config["APPLICATION_ROOT"] + "/" + session['currentUrl']

    return redirect(nextUrl)


@default.route("/redirect_from_page/<path:page>")
def route_redirect_from_page(page):
    """
    Redirect the user from a specific page.
    :param page: The page to start from, the user will be sent to next page in the list
    :return:
    """
    session['currentUrl'] = page_list.next_path(page)
    nextUrl = current_app.config["APPLICATION_ROOT"] + "/" + session['currentUrl']

    return redirect(nextUrl)


@default.route("/redirect_to_page/<path:page>")
def route_redirect_to_page(page):
    """
    Redirect the user to a specific page path in PAGE_LIST
    :param page:
    :return:
    """
    session['currentUrl'] = page
    nextUrl = current_app.config["APPLICATION_ROOT"] + "/" + session['currentUrl']

    return redirect(nextUrl)


@default.route("/end")
@verify_correct_page
@verify_session_valid
def route_end():
    """
    Ends the experiment and shows the user's completion code, if they have been given one.
    :return:
    """
    p = db.Participant.query.get(session['participantID'])
    p.timeEnded = datetime.datetime.utcnow()
    p.finished = True

    db.session.commit()

    return render_template('end.html', code=session['code'] if 'code' in session else None)


@default.route("/user_active")
def route_user_active():
    if 'participantID' in session:

BOFS/templates/consent.html
{% extends "template.html" %}
{% block head %}
    <script type="text/javascript">
        $(document).ready(function () {

            function dppx() {
                // devicePixelRatio: Webkit (Chrome/Android/Safari), Opera (Presto 2.8+), FF 18+
                return typeof window == 'undefined' ? 0 : +window.devicePixelRatio || ie() || 0
            }

            $("#screenWidth").val(window.screen.width);
            $("#screenHeight").val(window.screen.height);
            $("#innerWidth").val(window.innerWidth);
            $("#innerHeight").val(window.innerHeight);
            $("#dppx").val(dppx())

        });
    </script>

    <style>
        .hny{
            opacity: 0;
            position: absolute;
            top: 0;
            left: 0;
            height: 0;
            width: 0;
            z-index: -1;
        }
    </style>
{% endblock %}

{% block content %}

    <form id="form" class="needs-validation" method="post" novalidate>

        <input type="hidden" id="dppx" name="dppx">
        <input type="hidden" id="screenWidth" name="screenWidth">
        <input type="hidden" id="screenHeight" name="screenHeight">
        <input type="hidden" id="innerWidth" name="innerWidth">
        <input type="hidden" id="innerHeight" name="innerHeight">

        <i>Before proceeding, please read the following. You must give your consent to continue.</i>

        <div class="question">
            <div class="padding">
                {% if config['CONSENT_TEXT'] and config['CONSENT_TEXT'] != '' %}
                    {{ config['CONSENT_TEXT'] | safe }}
                {% else %}
                Please set the <pre>CONSENT_TEXT</pre> variable in the config file!
                {% endif %}
            </div>
        </div>

        <div class="question">
            <div class="padding">
                <b>Do you give your consent?</b>
                <div class="form-check">
                    <input class="form-check-input" type="radio" name="consent" id="consentYes" value="1" required>
                    <label class="form-check-label" for="consentYes">I give my consent</label>
                </div>
                <div class="form-check">
                    <input class="form-check-input" type="radio" name="consent" id="consentNo" value="0" required>
                    <label class="form-check-label" for="consentNo">I do not give my consent</label>
                </div>
                <div class="invalid-feedback">
                    You must provide your consent to continue.
                </div>
                <div class="hny">
                    <input type="email" name="email" id="email" value="">
                    <label for="email">Enter your email</label>
                </div>
            </div>
        </div>

        {{ btnContinue() }}

        <br>
    </form>

    <script>
        // Example starter JavaScript for disabling form submissions if there are invalid fields
        (function () {
            'use strict';
            window.addEventListener('load', function () {
                // Fetch all the forms we want to apply custom Bootstrap validation styles to
                var form = document.getElementById('form');
                var consentYes = document.getElementById('consentYes');

                form.addEventListener('submit', function (event) {
                    if (consentYes.checked !== true) {
                        document.getElementsByClassName('invalid-feedback').item(0).style.display = 'block';
                        event.preventDefault();
                        event.stopPropagation();
                    }
                }, false);

            }, false);
        })();
    </script>

{% endblock %}

BOFS/templates/end.html
{% extends "template.html" %}
{% block head %}
{% endblock %}

{% block content %}
        <b>Thanks for participating!</b>

        {% if code and (code != '0') %}
        <div class="question" style="background-color: #F8FFF7; width: 500px; margin-left: auto; margin-right: auto;">
            <div class="padding" style="text-align: center">
                Please copy and paste this code into the MTurk form:
                <br>
                <input type="text" value="{{ code }}" id="code" name="code" readonly style="text-align: center; margin-top: 5px; width: 350px;">
            </div>
        </div>
        {% endif %}
{% endblock %}

BOFS/templates/instructions.html
{% extends "template.html" %}
{% block head %}
{% endblock %}

{% block content %}

    <form id="form" method="post">
        <div class="question">
            <div class="padding">
                {{ instructions | safe }}
            </div>
        </div>
        {{ btnContinue(includeDiv=true) }}
    </form>

{% endblock %}

BOFS/templates/mturk_id.html
{% extends "template.html" %}
{% block head %}
{% endblock %}

{% block content %}

        <form id="form" method="post">

            <i>Welcome! Please fill out the following information to begin.</i><br>

            <div class="question" style="">
                <div class="padding">
                    <h3>Please enter your MTurk ID</h3>
                    <div>
                        <input class="form-control" type="text" name="mTurkID" id="mTurkID" style="width: 300px;" placeholder="" required />
                        <div class="invalid-feedback">
                            Please enter your MTurk Worker ID. You can find this on your MTurk dashboard.
                        </div>
                    </div>
                </div>
            </div>

        {{ btnContinue() }}

        </form>
{% endblock %}

BOFS/templates/questionnaire.html
{% extends "template.html" %}
{% from "questionnaire_macro.html" import createQuestionnaire with context %}
{% block head %}
{% endblock %}

{% block content %}

    <form id="form" method="post">

        {{ createQuestionnaire(q) }}

        {{ btnContinue() }}

    </form>

    <br>

{% endblock %}

BOFS/templates/questionnaire_macro.html
{% macro createQuestionnaire(q) -%}
        {% set default_field_width = 400 %}

        <input type="hidden" name="timeStarted" value="{{ timeStarted }}">

        {% if config["LOG_GRID_CLICKS"] %}
        <input type="hidden" id="gridItemClicks" name="gridItemClicks" value="">

        <script type="text/javascript">
            var grid_clicks = document.getElementById('gridItemClicks');

            function log_click(id, value) {
                grid_clicks.value += '{"id": "' + id + '", "time": "' + (Date.now() / 1000.0).toString() + '", "value": "' + value + '"};';
            }
        </script>
        {% endif %}

        <div id="instructions" style="font-style: italic;">{{ q.instructions | safe }}</div>

        <div id="q_s">
            {% for question in q.questions %}
                <div class="question padding">
                    {% if question.title %}
                        <h3>{{ question.title | safe }}</h3>
                    {% elif question.instructions %}
                        <h3>{{ question.instructions | safe }}</h3>
                    {% endif %}

                    <div>
                    {% if question.questiontype == "textview" %}
                        {{ question.text | safe }}
                    {% endif %}

                    {% if question.questiontype == "radiolist" %}
                        {% set lables = question.lables %}
                        {% if question.shuffle %}
                            {% do shuffle(question.labels) %}
                        {% endif %}
                        {% for label in question.labels %}
                        <div class="form-check {{ "form-check-inline" if question.horizontal else "" }}">
                            <input class="form-check-input" type="radio" name="{{ question.id }}" id="{{ question.id }}{{ loop.index }}" value="{{ label }}" {{ "required" if question.required }}>
                            <label class="form-check-label" for="{{ question.id }}{{ loop.index }}">{{ question.label_html[loop.index0] if question.label_html else label }}</label>
                        </div>
                        {% endfor %}
                    {% endif %}

                    {% if question.questiontype == "checklist" %}
                        {% if question.shuffle %}
                            {% do shuffle(question.questions) %}
                        {% endif %}

                        {% for check_question in question.questions %}
                        <div class="form-check {{ "form-check-inline" if question.horizontal else "" }}">
                            <input class="form-check-input" type="checkbox" name="{{ check_question.id }}" id="{{ check_question.id }}" value="1">
                            <label class="form-check-label" for="{{ check_question.id }}">{{ check_question.text | safe }}</label>
                        </div>
                        {% endfor %}
                    {% endif %}

                    {% if question.questiontype == "slider" %}
                        <div style="width: {{ question.width if question.width else default_field_width }}px;">
                            <label for="{{ question.id }}" style="float:left;">{{ question.left | safe }}</label>
                            <label for="{{ question.id }}" style="float:right;">{{ question.right | safe }}</label>
                            <div style="clear:both;"></div>
                        </div>
                        <input type="range" name="{{ question.id }}" id="{{ question.id }}" min="1" max="{{ question.tick_count }}" style="width: {{ question.width if question.width else default_field_width }}px;">
                    {% endif %}

                    {% if question.questiontype == "field" %}
                        <input class="form-control" type="text" name="{{ question.id }}" id="{{ question.id }}" placeholder="{{ question.placeholder }}" style="width: {{ question.width if question.width else default_field_width }}px; height: 36px;" {{ "required" if question.required }}>
                    {% endif %}

                    {% if question.questiontype == "num_field" %}
                        <input class="form-control" type="number" name="{{ question.id }}" id="{{ question.id }}" {{ 'min=%s' % question.min if question.min }} {{ 'max=%s' % question.max if question.max }} style="width: {{ question.width if question.width else default_field_width }}px; height: 36px;" {{ "required" if question.required }}>
                    {% endif %}

                    {% if question.questiontype == "multi_field" %}
                        <textarea class="form-control" placeholder="{{ question.placeholder }}" name="{{ question.id }}" id="{{ question.id }}" style="width: {{ question.width if question.width else default_field_width }}px; height: {{ question.height if question.height else 80 }}px;" {{ "required" if question.required }}></textarea>
                    {% endif %}

                    {% if question.questiontype == "drop_down" %}
                        <select class="form-control" name="{{ question.id }}" id="{{ question.id }}" style="width: {{ question.width if question.width else default_field_width }}px; height: 36px;" {{ "required" if question.required }}>
                            <option value="" disabled selected>Select an option</option>
                            {% for item in question["items"] %}
                            <option>{{ item }}</option>
                            {% endfor %}
                        </select>
                    {% endif %}

                    {% if question.questiontype == "radiogrid" %}
                        {% if question.shuffle %}
                            {% do shuffle(question.q_text) %}
                        {% endif %}
                        <table width="100%">
                            <thead>
                                <tr>
                                    <th></th>
                                    {% for label in question.labels %}
                                    <th scope="col" style="text-align:center;">{{ label }}</th>
                                    {% endfor %}
                                </tr>
                            </thead>
                            <tbody>
                                {% for grid_question in question.q_text %}
                                <tr class="{{ "oddRow" if loop.index % 2 == 0 else "evenRow" }}">
                                    <td style="width: 30%">{{ grid_question.text }}</td>
                                    {% for label in question.labels %}
                                    <td style="text-align: center; width: {{ 70.0 / (question.labels | length) }}%">
                                        <label style="padding: 0; width: 100%; margin:auto; height: 28px; text-align:center;" class="btn btn-lg btn-default">
                                            <div class="" style="display:inline;">
                                                <input class="" title="{{ label }}" type="radio" name="{{ grid_question.id }}" id="{{ grid_question.id }}{{ loop.index }}" value="{{ loop.index }}" required  {{ 'onclick="log_click(\'{}\', {})"'.format(grid_question.id, loop.index) | safe if config["LOG_GRID_CLICKS"] }}>
                                            </div>
                                        </label>
                                    </td>
                                    {% endfor %}
                                </tr>
                                {% endfor %}
                            </tbody>
                        </table>
                    {% endif %}
                    </div>
                </div>
            {% endfor %}
        </div>

        {{ q.code |safe if q.code }}
{%- endmacro %}

BOFS/templates/template.html
{% macro btnContinue(includeDiv=true) -%}
    {% if includeDiv %}
        <div class="navigation padding">
            <div style="float: right">
    {% endif %}
                <input class="btn btn-light" style="width: 160px;" id="btnNext" type="submit" value="Continue">
    {% if includeDiv %}
            </div>
            <div style="clear: both"></div>
        </div>
    {% endif %}
{%- endmacro %}
<!DOCTYPE html>
<html>
<head>
    <title>{% block title %}{{ config['TITLE'] }}{% endblock %}</title>
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/css/all.min.css" integrity="sha256-UzFD2WYH2U1dQpKDjjZK72VtPeWP50NoJjd26rnAdUI=" crossorigin="anonymous" />
    <link rel="stylesheet" href="{{ url_for('BOFS_static', filename='style.css') }}" type="text/css" />

    <script src="{{ url_for('BOFS_static', filename='js/jquery-3.4.1.min.js') }}"></script>
    <script src="{{ url_for('BOFS_static', filename='js/popper.min.js') }}"></script>
    <script src="{{ url_for('BOFS_static', filename='js/bootstrap.min.js') }}"></script>
    {% block head %}{% endblock %}
</head>
<body>

<div class="title-bar">
    <div class="title-text">
        {% if config['USE_LOGO'] %}<div style="float: right"><img src="{{ url_for('BOFS_static', filename='logo.png') }}"></div>{% endif %}
        <div style="float: left; padding-top: 2px;">{{ config['TITLE'] }}</div>
    </div>
</div>
<br>

<div style="width: 967px; margin-left: auto; margin-right: auto;" class="content">
    <div class="questions">
        {% if crumbs and config['USE_BREADCRUMBS'] %}
        <div>
        {% for crumb in crumbs %}
            {% if crumb['active'] %}
                <b>{{ crumb['name'] }}</b>
            {% else %}
                {{ crumb['name'] }}
            {% endif %}
            {% if not loop.index == (crumbs | length) %}&#8594;{% endif %}
        {% endfor %}
        <br>&nbsp;
        </div>
        {% endif %}

        {% block top %}
        {% endblock %}

        {% block content %}
        {% endblock %}

        {% block bottom %}
        {% endblock %}
    </div>
</div>

{% if (session.get('loggedIn', False) or debug) and session.get('participantID', False) and request.blueprint != 'admin' %}
<div class="fixed-bottom debug-menu bg-dark">
    <div class="row">
        <div class="col-sm-2" style="text-align:left;">
            <a href="/redirect_previous_page" class="btn btn-light btn-sm" role="button" style="width: 50px;"><i class="fas fa-arrow-circle-left"></i></a>
        </div>
        <div class="col-sm-2 dropup" style="text-align:center; padding: 0 8px;">
            <button class="btn btn-light btn-sm dropdown-toggle" style="width: 100%;" data-toggle="dropdown">Skip to page... <i class="fas fa-file"></i></button>
            <div class="dropdown-menu">
                {% for page in flat_page_list %}
                <a class="dropdown-item" href="/redirect_to_page/{{ page.path }}">{{ page }}</a>
                {% endfor %}
            </div>
        </div>
        <div class="col-sm-2" style="text-align:center; padding: 0 8px;">
            <a href="/restart" class="btn btn-light btn-sm" role="button" style="width: 100%;">Restart <i class="fas fa-redo"></i></a>
        </div>
        <div class="col-sm-2" style="text-align:center; padding: 0 8px;">
            <a href="/admin" class="btn btn-light btn-sm" role="button" style="width: 100%;">Admin Panel <i class="fas fa-tools"></i></a>
        </div>
        <div class="col-sm-2 dropup" style="text-align:center; padding: 0 8px;">
            <a href="#" class="btn btn-light btn-sm dropdown-toggle" role="button" data-toggle="dropdown" style="width: 100%;">Session Variables <i class="fas fa-clipboard-list"></i></a>
            <div class="dropdown-menu debug-session">
                <ul>
                    {% for variable in session %}
                        <li>{{ variable }}: <pre>{{ session[variable] }}</pre></li>
                    {% endfor %}
                </ul>
            </div>
        </div>
        <div class="col-sm-2" style="text-align:right;">
            <a href="/redirect_next_page" class="btn btn-light btn-sm" role="button" style="width: 50px;"><i class="fas fa-arrow-circle-right"></i></a>
        </div>
    </div>
</div>
{% endif %}

<script type="text/javascript">
    {% if 'currentUrl' in session and session['currentUrl'] %}
        setInterval(function() {
            $.ajax({
                url: "{{ url_for('default.route_user_active') }}",
                dataType: "html",
                success: function(data) {}
            });
        }, 30000);

        // Redirect user to the correct page if they are on the wrong page.
        window.onload = function() {
            if (window.location.pathname.includes("admin")) {
                return;
            }

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState === 4 && this.status === 200) {
                    if (window.location.pathname.substr(1) != this.responseText)  {
                        window.location.href = "/" + this.responseText;
                    }
                }
            };
            xhttp.open("GET", "/current_url", true);
            xhttp.send();
        };
        window.onunload = function(){};
    {% endif %}
</script>

</body>
</html>